
#include <windows.h>  
#include "CheckBox3.h" 


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;          // current instance
int cbstatus1=0, cbstatus2=0; /* holds status of check boxes */
int rbstatus1=0, rbstatus2=0; /* holds status of check boxes */

LPCTSTR lpszAppName  = "DlgBox";
LPCTSTR lpszTitle    = "Chap08"; 

BOOL RegisterWin95( CONST WNDCLASS* lpwc );
extern LRESULT CALLBACK DialogFunc(HWND hdwnd, UINT message,
                            WPARAM wParam, LPARAM lParam);

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadIcon(wcex.hInstance, "SMALL");
			
   return RegisterClassEx( &wcex );
}


/* This function is called by Windows 95 and is passed 
   messages from the message queue.  */
LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
  char str[255];

  switch(message) {
    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDM_TEST: 
          DialogBox(hInst, "TESTDIALOG", hWnd, (DLGPROC)DialogFunc);
          break;
        case ID_STATUS:
          if(cbstatus1) strcpy(str, "Checkbox 1 is checked\n");
             else strcpy(str, "Checkbox 1 is not checked\n");
          if(cbstatus2) strcat(str, "Checkbox 2 is checked\n");
			else strcat(str, "Checkbox 2 is not checked\n");
          if(rbstatus1) strcat(str, "Radio 1 is checked\n");
			else strcat(str, "Radio 1 is not checked\n");
          if(rbstatus2) strcat(str, "Radio 2 is checked");
			else strcat(str, "Radio 2 is not checked");
          MessageBox(hWnd, str, "", MB_OK);
          break;
      }
      break;
    case WM_DESTROY: /* terminate the program */
      PostQuitMessage(0);
      break;
    default: 
      /* Let Windows 95 process any messages not specified in
      the preceding switch statement. */
      return DefWindowProc(hWnd, message, wParam, lParam);
  }
  return 0;
}


/* A simple dialog function. */
LRESULT CALLBACK DialogFunc(HWND hdwnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
  switch(message) {
    case WM_INITDIALOG:
      /* The dialog box has just been displayed.  Set
         the check boxes and radio buttons appropriately. */
      SendDlgItemMessage(hdwnd, ID_CB1, BM_SETCHECK, cbstatus1, 0);
      SendDlgItemMessage(hdwnd, ID_CB2, BM_SETCHECK, cbstatus2, 0);
      SendDlgItemMessage(hdwnd, ID_RB1, BM_SETCHECK, rbstatus1, 0);
      SendDlgItemMessage(hdwnd, ID_RB2, BM_SETCHECK, rbstatus2, 0);
      return 1;
    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDCANCEL:
          EndDialog(hdwnd, 0);
          return 1;
        case IDOK:
          /* update global check box status variables */
          cbstatus1 = SendDlgItemMessage(hdwnd, ID_CB1,
             BM_GETCHECK, 0, 0);  // is box checked?
          cbstatus2 = SendDlgItemMessage(hdwnd, ID_CB2,
             BM_GETCHECK, 0, 0);  // is box checked?
 
          /* now, update global check box status variables */
          rbstatus1 = SendDlgItemMessage(hdwnd, ID_RB1,
             BM_GETCHECK, 0, 0);  // is button checked?
          rbstatus2 = SendDlgItemMessage(hdwnd, ID_RB2,
             BM_GETCHECK, 0, 0);  // is button checked?

          EndDialog(hdwnd, 0);
          return 1;
      case ID_CB1: /* This is a manually managed check box. */
        /* user selected 1st check box, so change its state */
          if(!SendDlgItemMessage(hdwnd, ID_CB1, BM_GETCHECK, 0, 0))
         SendDlgItemMessage(hdwnd, ID_CB1, BM_SETCHECK, 1, 0);
          else /* turn it off */
         SendDlgItemMessage(hdwnd, ID_CB1, BM_SETCHECK, 0, 0);
          return 1;
      }
  }
  return 0;
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

      case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDCANCEL:
          EndDialog(hDlg, 0);
          return 1;

          return 1;
      }
   }

   return (FALSE); 
}
