
#include <windows.h>  
#include "All13.h" 
#include <commctrl.h>
#include "resource.h"

#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "DlgBox";
LPCTSTR lpszTitle    = "Dialog Box"; 
#define ID_UPDOWN  701

BOOL RegisterWin95( CONST WNDCLASS* lpwc );

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   InitCommonControls();

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadIcon(wcex.hInstance, "SMALL");
			
   return RegisterClassEx( &wcex );
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )
   {
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                        DialogBox( hInst, "TestDialog", hWnd,
                                   (DLGPROC)TestDlgProc );
                        break;
                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK TestDlgProc( HWND hDlg, UINT uMsg, 
                              WPARAM wParam, LPARAM lParam )
{
  static long udpos = 0;
  static long trackpos = 0;
  static HWND hEboxWnd;
  static HWND hTrackWnd;
  static HWND udWnd;
  int low=0, high=10;

   switch( uMsg )
   {
    case WM_INITDIALOG:
	   hEboxWnd = GetDlgItem(hDlg, ID_EB1);
	   udWnd = CreateUpDownControl(
                    WS_CHILD | WS_BORDER | WS_VISIBLE |
                    UDS_SETBUDDYINT | UDS_ALIGNRIGHT,
                    10, 10, 50, 50,
                    hDlg,
                    ID_UPDOWN,
                    hInst,
                    hEboxWnd,
                    high, low, high/2);

      /* Create a trackbar */
      hTrackWnd = CreateWindow(TRACKBAR_CLASS,
                    "Trackbar", /* not used in this example */
                    WS_CHILD | WS_VISIBLE | WS_TABSTOP |
                    TBS_AUTOTICKS | WS_BORDER, 
                    0, 70,
                    200, 30,
                    hDlg,
                    NULL,
                    hInst,
                    NULL
      );
      SendMessage(hTrackWnd, TBM_SETRANGE,
                  (WPARAM) 1, (LPARAM) MAKELONG(low, high));              
      SendMessage(hTrackWnd, TBM_SETPOS,
                  (WPARAM) 1, (LPARAM) high/2);              
      return 1;

    case WM_COMMAND :
            switch( LOWORD( wParam ) )
            {
               case IDOK :
                    EndDialog( hDlg, IDOK );
                    break;
               case IDCANCEL : 
                    EndDialog( hDlg, IDCANCEL );
                    break;
			}
            break;
	 case WM_VSCROLL: /* process up-down control */
     if(udWnd==(HWND)lParam) {
        trackpos = GetDlgItemInt(hDlg, ID_EB1, NULL, 1);
        SendMessage(hTrackWnd, TBM_SETPOS, (WPARAM) 1, 
			(LPARAM) trackpos);
	 }
     return 1;




   case WM_HSCROLL: /* trackbar was activated */
      if(hTrackWnd != (HWND)lParam) break; /* not trackbar */
      
      switch(LOWORD(wParam)) {
         case TB_TOP: 
         case TB_BOTTOM:        /* For this example */
         case TB_LINEDOWN:      /* all messages will be */
         case TB_LINEUP:        /* processed in the same */
         case TB_THUMBPOSITION: /* way. */
         case TB_THUMBTRACK:
         case TB_PAGEUP:
         case TB_PAGEDOWN:
            trackpos = SendMessage(hTrackWnd, TBM_GETPOS,
                     0, 0);              
            SetDlgItemInt(hDlg, ID_EB1, trackpos, 1);
         return 1;
	  }
      break;
      default :
            return( FALSE );
   }

   return( TRUE );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

      case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDCANCEL:
          EndDialog(hDlg, 0);
          return 1;
      }
   }

   return (FALSE); 
}
