#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "TabCtl2.h"
#define IS_WIN32 TRUE


#define NUMPARTS 3

BOOL CALLBACK DlgFunc1(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DlgFunc2(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DlgFunc3(HWND, UINT, WPARAM, LPARAM);
void InitStatus(HWND hWnd);

HINSTANCE hInst;        // current instance
HWND hWnd; 
HWND hTabWnd;
HWND hStatusWnd;
HWND hDlg = (HWND) NULL;
LPCTSTR lpszAppName = "Generic";
LPCTSTR lpszTitle =   "Generic Application";
BOOL RegisterWin95(CONST WNDCLASS* lpwc);


int parts[NUMPARTS];

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
 {
   TC_ITEM tci;
   MSG msg;
   WNDCLASS wc;


   wc.style          = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc    = (WNDPROC)WndProc;
   wc.cbClsExtra     = 0;
   wc.cbWndExtra     = 0;
   wc.hInstance      = 0;
   wc.hIcon          = LoadIcon(hInstance, lpszAppName);
   wc.hCursor        = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName   = lpszAppName;
   wc.lpszClassName  = lpszAppName;
 

   if(!RegisterWin95(&wc))
      return false;
   hInst = hInstance; /* save the current instance handle */

   hWnd = CreateWindow (lpszAppName,
                        lpszTitle,
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0,
                        CW_USEDEFAULT, 0,
                        NULL,
                        NULL,
                        hInstance,
                        NULL
                       );
   if(!hWnd)
      return false;


   InitCommonControls();



   hTabWnd = CreateWindow(
              WC_TABCONTROL,
              "",
              WS_VISIBLE | WS_TABSTOP | WS_CHILD,
              20, 20, 325, 250,
              hWnd,
              NULL,
              hInst,
              NULL
            );
   tci.mask = TCIF_TEXT;

   tci.iImage = -1;

   tci.pszText = "Options";
   TabCtrl_InsertItem(hTabWnd, 0, &tci);

   tci.pszText = "Pitch";
   TabCtrl_InsertItem(hTabWnd, 1, &tci);

   tci.pszText = "Page Size";
   TabCtrl_InsertItem(hTabWnd, 2, &tci);

   hDlg = CreateDialog(hInst, "MYDB1", hTabWnd, DlgFunc1);

   /* Display the window. */
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   /* Create the message loop. */
   while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg); /* allow use of keyboard */
    DispatchMessage(&msg); /* return control to Windows */
  }
  return msg.wParam;
}


/* This function is called by Windows 95 and is passed
   messages from the message queue.
*/
LRESULT CALLBACK WndProc(HWND hwnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
  NMHDR *nmptr;
  int tabnumber = 0;
  switch(message) {
    case WM_COMMAND:
         switch(LOWORD(wParam))
          {
            case IDM_TEST :
               break;
            case IDM_EXIT :
               DestroyWindow(hWnd);
               break;
          }
         break;
    case WM_NOTIFY:
      nmptr = (LPNMHDR) lParam;
      if(nmptr->code == TCN_SELCHANGE) {
        if(hDlg) DestroyWindow(hDlg);
        tabnumber = TabCtrl_GetCurSel((HWND)nmptr->hwndFrom);
        switch(tabnumber) {
          case 0:
            hDlg = CreateDialog(hInst, "MYDB1",
                         hTabWnd, DlgFunc1);
            break;
          case 1:
            hDlg = CreateDialog(hInst, "MYDB2",
                         hTabWnd, DlgFunc2);
            break;
          case 2:
            hDlg = CreateDialog(hInst, "MYDB3",
                         hTabWnd, DlgFunc3);
            break;
        }
      }
      break;
    case WM_DESTROY: /* terminate the program */
      if(hDlg) DestroyWindow(hDlg);
      PostQuitMessage(0);
      break;
    default:
     /* Let Windows 95 process any messages not specified in
        the preceding switch statement. */
     return DefWindowProc(hwnd, message, wParam, lParam);
  }
  return 0;
}
/* First dialog function. */
BOOL CALLBACK DlgFunc1(HWND hDlg, UINT message,
                          WPARAM wParam, LPARAM lParam)
{
  static long udpos = 0;
  static char str[80];
  static HWND hEboxWnd;
  static HWND udWnd;
  static statusCB1, statusCB2;
  int low=0, high=20;

  switch(message) {
    case WM_INITDIALOG:
      InitStatus(hDlg);

      hEboxWnd = GetDlgItem(hDlg, ID_EB1);
      udWnd = CreateUpDownControl(
                    WS_CHILD | WS_BORDER | WS_VISIBLE |
                    UDS_SETBUDDYINT | UDS_ALIGNRIGHT,
                    10, 10, 50, 50,
                    hDlg,
                    ID_UPDOWN,
                    hInst,
                    hEboxWnd,
                    high, low, high/2);
     return 1;
    case WM_VSCROLL: /* process up/down control */
      if(udWnd==(HWND)lParam) {
        udpos = GetDlgItemInt(hDlg, ID_EB1, NULL, 1);
        sprintf(str, "Up-down: %d", udpos);
        SendMessage(hStatusWnd, SB_SETTEXT,
                    (WPARAM) 0, (LPARAM) str);
      }
      return 1;
    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case ID_CB1: /* process check box 1 */
          statusCB1 = SendDlgItemMessage(hDlg, ID_CB1,
                      BM_GETCHECK, 0, 0);
          if(statusCB1) sprintf(str, "Option 1: ON");
          else sprintf(str, "Option 1: OFF");
          SendMessage(hStatusWnd, SB_SETTEXT,
                      (WPARAM) 1, (LPARAM) str);

          return 1;
        case ID_CB2: /* process check box 2 */
          statusCB2 = SendDlgItemMessage(hDlg, ID_CB2,
                      BM_GETCHECK, 0, 0);
          if(statusCB2) sprintf(str, "Option 2: ON");
          else sprintf(str, "Option 2: OFF");
          SendMessage(hStatusWnd, SB_SETTEXT,
                      (WPARAM) 2, (LPARAM) str);
          return 1;
        case ID_RESET: /* reset options */
          SendMessage(udWnd, UDM_SETPOS, 0, (LPARAM) high /2);
          SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 0,
              (LPARAM) "Up-down: 10");
          SendDlgItemMessage(hDlg, ID_CB1,
                      BM_SETCHECK, 0, 0);
          SendDlgItemMessage(hDlg, ID_CB2,
                      BM_SETCHECK, 0, 0);
          SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 1,
              (LPARAM) "Option 1: OFF");
          SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 2,
              (LPARAM) "Option 2: OFF");
          return 1;
        case IDCANCEL:
        case IDOK:
          PostQuitMessage(0);
          return 1;
      }
  }
  return 0;
}
/* Second dialog function. This is just a placeholder. */
BOOL CALLBACK DlgFunc2(HWND hdwnd, UINT message,
                          WPARAM wParam, LPARAM lParam)
{
  switch(message) {
    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDOK:
          PostQuitMessage(0);
          return 1;
      }
  }
  return 0;
}

/* Third dialog function. This is just a placeholder. */
BOOL CALLBACK DlgFunc3(HWND hdwnd, UINT message,
                          WPARAM wParam, LPARAM lParam)
{
  switch(message) {
    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDOK:
          PostQuitMessage(0);
          return 1;
      }
  }
  return 0;
}

/* Initialize the status bar. */
void InitStatus(HWND hWnd)
{
  RECT WinDim;
  int i;
  GetClientRect(hWnd, &WinDim);

  for(i=1; i<=NUMPARTS; i++)
    parts[i-1] = WinDim.right/NUMPARTS * i;

  /* Create a status bar */
  hStatusWnd = CreateWindow(STATUSCLASSNAME,
               "", /* not used in this example */
               WS_CHILD | WS_VISIBLE,
               0, 0, 0, 0,
               hWnd,
               NULL,
               hInst,
               NULL
      );

  SendMessage(hStatusWnd, SB_SETPARTS,
              (WPARAM) NUMPARTS, (LPARAM) parts);

  SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 0,
              (LPARAM) "Up-down: 10");
  SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 1,
              (LPARAM) "Option 1: OFF");
  SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 2,
              (LPARAM) "Option 2: OFF");
}


BOOL RegisterWin95(CONST WNDCLASS* lpwc)
 {
   WNDCLASSEX wcex;

   wcex.style           = lpwc->style;
   wcex.lpfnWndProc     = lpwc->lpfnWndProc;
   wcex.cbClsExtra      = lpwc->cbClsExtra;
   wcex.cbWndExtra      = lpwc->cbWndExtra;
   wcex.hInstance       = lpwc->hInstance;
   wcex.hIcon           = lpwc->hIcon;
   wcex.hCursor         = lpwc->hCursor;
   wcex.hbrBackground   = lpwc->hbrBackground;
   wcex.lpszMenuName    = lpwc->lpszMenuName;
   wcex.lpszClassName   = lpwc->lpszClassName;
   wcex.cbSize          = sizeof(WNDCLASSEX);
   wcex.hIconSm         = LoadIcon(wcex.hInstance, "SMALL");
   return RegisterClassEx(&wcex);
 }

