#include "genstub.cpp"
#include "resource.h"

void ShowError()
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
		);
// Process any inserts in lpMsgBuf.
// ...
// Display the string.
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, NULL, MB_OK | MB_ICONINFORMATION );
// Free the buffer.
		LocalFree( lpMsgBuf );

}


void ShowTimes(HWND hWnd,HANDLE child1, HANDLE child2)
{
	
    FILETIME ftCreate, ftExit, ftKernel, ftUser;
	HDC hdc;

	hdc = GetDC(hWnd); /* get device context */

   
    
    
    if ( GetThreadTimes( child1, &ftCreate, &ftExit, &ftKernel, &ftUser))
    {
        // Horrible, disgusting hack!  The two lines below basically grab the
        // contents of a FILETIME structure and store it in a 64 bit integer.
        LONGLONG tUser64 = *(LONGLONG *)&ftUser;
        LONGLONG tKernel64 = *(LONGLONG *)&ftKernel;
        DWORD tUser, tKernel;

        // The LONGLONGs contain the time in 100 nanosecond intervals (now
        // there's a useful unit of measurement...).  Divide each of them by
        // 10000 to convert into milliseconds, and store the results in a
        // DWORD.  This means that the max time before overflowing is around
        // 4 Million seconds (about 49 days)
        tUser = (DWORD)(tUser64 / 10000);
        tKernel = (DWORD)(tKernel64 / 10000);

        // Format the user and kernel times, and add to the process node
        char szItem[128];
		wsprintf( szItem, "First thread times");
		TextOut(hdc, 10, 100, szItem, strlen(szItem)); /* output string */
        wsprintf( szItem, "User mode: %u ms", tUser );
		TextOut(hdc, 30, 120, szItem, strlen(szItem)); /* output string */
        wsprintf( szItem, "Kernel mode: %u ms", tKernel );
        TextOut(hdc, 30, 140, szItem, strlen(szItem)); /* output string */
    }
	else
		ShowError();

   if ( GetThreadTimes( child2, &ftCreate, &ftExit, &ftKernel, &ftUser))
    {
        // Horrible, disgusting hack!  The two lines below basically grab the
        // contents of a FILETIME structure and store it in a 64 bit integer.
        LONGLONG tUser64 = *(LONGLONG *)&ftUser;
        LONGLONG tKernel64 = *(LONGLONG *)&ftKernel;
        DWORD tUser, tKernel;

        // The LONGLONGs contain the time in 100 nanosecond intervals (now
        // there's a useful unit of measurement...).  Divide each of them by
        // 10000 to convert into milliseconds, and store the results in a
        // DWORD.  This means that the max time before overflowing is around
        // 4 Million seconds (about 49 days)
        tUser = (DWORD)(tUser64 / 10000);
        tKernel = (DWORD)(tKernel64 / 10000);

        // Format the user and kernel times, and add to the process node
        char szItem[128];
		wsprintf( szItem, "Second thread times:");
		TextOut(hdc, 10, 160, szItem, strlen(szItem)); /* output string */
        wsprintf( szItem, "User mode: %u ms", tUser );
		TextOut(hdc, 30, 180, szItem, strlen(szItem)); /* output string */
        wsprintf( szItem, "Kernel mode: %u ms", tKernel );
        TextOut(hdc, 30, 200, szItem, strlen(szItem)); /* output string */
    }
	else 
	    ShowError();
}


void ShowProcessTimes(HWND hWnd)
{
	
    FILETIME ftCreate, ftExit, ftKernel, ftUser;
	HDC hdc;

	hdc = GetDC(hWnd); /* get device context */

   
    
    
    if (GetProcessTimes( GetCurrentProcess(), &ftCreate, &ftExit, &ftKernel, &ftUser))
    {
        // Horrible, disgusting hack!  The two lines below basically grab the
        // contents of a FILETIME structure and store it in a 64 bit integer.
        LONGLONG tUser64 = *(LONGLONG *)&ftUser;
        LONGLONG tKernel64 = *(LONGLONG *)&ftKernel;
        DWORD tUser, tKernel;

        // The LONGLONGs contain the time in 100 nanosecond intervals (now
        // there's a useful unit of measurement...).  Divide each of them by
        // 10000 to convert into milliseconds, and store the results in a
        // DWORD.  This means that the max time before overflowing is around
        // 4 Million seconds (about 49 days)
        tUser = (DWORD)(tUser64 / 10000);
        tKernel = (DWORD)(tKernel64 / 10000);

        // Format the user and kernel times, and add to the process node
        char szItem[128];
        wsprintf( szItem, "Process times:");
		TextOut(hdc, 10, 220, szItem, strlen(szItem)); /* output string */
		wsprintf( szItem, "User mode: %u ms", tUser );
		TextOut(hdc, 30, 240, szItem, strlen(szItem)); /* output string */
        wsprintf( szItem, "Kernel mode: %u ms", tKernel );
        TextOut(hdc, 30, 260, szItem, strlen(szItem)); /* output string */
    }
	else
		ShowError();

}



DWORD WINAPI ThreadProc(HWND hWnd)
{
    TCHAR szBuffer[128];
    wsprintf( szBuffer, "Starting Thread ID = %lX", GetCurrentThreadId() );
    SetWindowText( hWnd, szBuffer );
    for(int i=0;i==0;);
    wsprintf( szBuffer, "Thread %lX finished execution", GetCurrentThreadId() );
    SetWindowText( hWnd, szBuffer );

    ExitThread( TRUE );
	return ( TRUE );
}


DWORD WINAPI ThreadProc2(HWND hWnd)
{
    TCHAR szBuffer[128];
	HDC hdc;

	hdc = GetDC(hWnd); /* get device context */

    wsprintf( szBuffer, "Starting Thread ID = %lX", GetCurrentThreadId() );
    TextOut(hdc, 10, 10, szBuffer, strlen(szBuffer)); /* output string */

    wsprintf( szBuffer, "Thread %lX finished execution", GetCurrentThreadId() );
	
    TextOut(hdc, 10, 10, szBuffer, strlen(szBuffer)); /* output string */

	ReleaseDC(hWnd, hdc); /* release device context */
	for(int i=0;i==0;);
    ExitThread( TRUE );

	return ( TRUE );
}
// Windows message procedure.
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static  HANDLE hChild = 0, hChild2=0;
   switch (uMsg)
   {
       case WM_COMMAND:       // Process menu items.
               switch ( LOWORD( wParam )  )
               {
                  case IDM_TEST:
                    {
                     DWORD dwExitCodeThread, dwExitCodeThread2;
                     DWORD dwChild, dwChild2;
                     if (hChild)
						GetExitCodeThread( hChild, &dwExitCodeThread );
                     if (dwExitCodeThread!=STILL_ACTIVE)
                         hChild = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE )ThreadProc, hWnd, 0, &dwChild );
					 else {
						if (hChild2)
							GetExitCodeThread( hChild2, &dwExitCodeThread2 );
						if (dwExitCodeThread2!=STILL_ACTIVE)
						   hChild2 = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE )ThreadProc2, hWnd, 0, &dwChild2 );
					 }	

					 

                    }
                  break;
				  case ID_SHOWPROCESS:
					  ShowProcessTimes(hWnd);	
					  break;
				  case ID_STOP2:
					  TerminateThread(hChild2, FALSE);
					  break;
				  case IDM_GET_TIME:
					  {
							ShowTimes(hWnd,hChild, hChild2);
					  }
					  break;
                  case IDM_EXIT:
                       DestroyWindow( hWnd );
                       break;
               }
               break;
       case WM_DESTROY:
			   TerminateThread(hChild, FALSE);
			   TerminateThread(hChild2, FALSE);
			   PostQuitMessage( 0 );
               break;
          break;
       default:
            return DefWindowProc( hWnd, uMsg, wParam, lParam );
   }
   return NULL;
}